;
; Pyramid solution 
;
; (C) Sniper/Scarab 27.06.2010
;
; Based on Genetic Algorithms.
;
; I did not implemented mutations because it does not 
; really help to solve the problem.
;
; I implemented it in some hours work. 
; Its not very optimized and I think not the fastest and not the smalles solution.
;
; Template 3 and 5 takes ages on a amiga but on a dualcore Pentium its like 10 seconds ;)
;
;


ANIMAL_COUNT 	EQU	32

	
; a0 = pyramid
; a1 = space (should be cleared)
; d0 = rows
;
pyramid_solver:
	move.l	(a0),d2		; maxval = top/(rows)
	divu.l	d0,d2
	move.l	d2,max_val

	subq	#1,d0		; better for loop counters and calc	

	; get last row of the pyramid
	move.l	a0,a3
	move	d0,d1
.lastrowlp
	lea	(a3,d1.w*4),a3
	dbra	d1,.lastrowlp

	; copy orignal data to buffer
	move.l	a1,a2
	move.l	a3,a6
	move	d0,d1
.backuplp
	move.l	(a6)+,(a1)+
	dbra	d1,.backuplp


	; init all animals
	move.l	a1,a4
	move	#ANIMAL_COUNT-1,d7
.initalp
	move.l	a3,a5
	move	d0,d6	
.initlp
	move.l	(a5)+,d2
	bne.s	.initstore
	moveq	#1,d2
.initstore
	move.l	d2,(a4)+
	dbra	d6,.initlp
	dbra	d7,.initalp

; d0 = rows-1
; a0 = pyramid
; a1 = free space
; a2 = backup
; a3 = pyramidlastrow

	moveq	#0,d4				; best animal
	move.l	#$7fffffff,d5			; best fitness

	; dna step loop
.dnasteplp
	move.l	a1,a4
	
; d4 = best animal

	move	#ANIMAL_COUNT-1,d3
.animalsteplp

	; jitter the animal

	; but do not jitter the best animal
	cmp	d4,d3
	beq.s	.skipjitter
	
	bsr.w	animal_jitter_and_to_pyramid
	bra.s	.endjitter
.skipjitter
	bsr.w	animal_to_pyramid
.endjitter

	; rollout the whole pyramid and calculate the top value

	lea	(a3,d0.w*4),a5			; end of last row
	move.l	a3,a6				; end of upper row
	move	d0,d7
	subq	#1,d7				; one row less
.calcylp
	move	d7,d6
.calcxlp
	move.l	(a5),d2				
	add.l	-(a5),d2
	move.l	d2,-(a6)
	dbra	d6,.calcxlp
	subq	#1,d7
	subq.l	#4,a5
	bne.s	.calcylp

	move.l	(a5),d1				; p[0]
	add.l	-(a5),d1			; + p[1]
	; top value result -> d1


	sub.l	(a0),d1				; get diff
	beq.b 	.foundperfectanimal		; DONE!
	bpl.s	.ispos
	neg.l	d1				; ABS
.ispos
	cmp.l	d5,d1				; found best animal?
	bge.s	.nobest
	move.l	d1,d5
	move.l	d3,d4
.nobest

.nextanimalstep
	dbra	d3,.animalsteplp


	; crossover animals

	move.l	a1,a5
	move	#ANIMAL_COUNT-1,d2
	sub	d4,d2
	move	d0,d6
	addq	#1,d6
	mulu	d6,d2
	lea	(a1,d2.w*4),a4
	
	move	#ANIMAL_COUNT-1,d7
.crossoveralp
	bsr.b	random
	; d1 = random val
		
	move	d0,d6
	move.l	a4,a6
.crossoverlp
	move.l	(a6)+,d2
	lsl.l	#1,d1
	bcc.s	.skipcross
	move.l	(a5),d2
.skipcross
	move.l	d2,(a5)+
	dbra	d6,.crossoverlp
.crossnext
	dbra	d7,.crossoveralp

	; debug exit
	;btst	#6,$bfe001
	;beq.s	.foundperfectanimal
	
	; try next step
	bra.b	.dnasteplp

.foundperfectanimal:
	rts	


; d1 -> rand
; trash a6
random:
	move.l	a6,-(sp)
	lea	rand_val(pc),a6
	move.l	(a6),d1
	rol.l	d1,d1
	addq.l	#7,d1
	move.l	d1,(a6)
	move.l	(sp)+,a6
	rts


; d0 = rows-1
; a0 = pyramid
; a1 = space
; a2 = backup
; a3 = pyramidlastrow
; a4 = animal
animal_jitter_and_to_pyramid:
	move.l	a3,a6	
	move.l	a2,a5
	move	d0,d6
	move.l	max_val(pc),d7
	bsr.b	random
		
.jitterlp
	move.l	(a5)+,d2	; original value != 0?
	bne.s	.storeval
	
	move.l	(a4),d2		; animal val

	; generate new rnd
	rol.l	d1,d1
	
	btst	#0,d1
	bne.s	.noaddjitter
	cmp.l	d7,d2
	bge.s	.noaddjitter	
	addq.l	#1,d2
	bne.s	.storeval
	moveq.l	#1,d2
	bra.s	.storeval
.noaddjitter

	btst	#1,d1
	bne.s	.storeval
	subq.l	#1,d2
	bne.s	.storeval

	moveq	#1,d2
	
.storeval
	move.l	d2,(a4)+	; store old or new value
	move.l	d2,(a6)+
	dbra	d6,.jitterlp
	rts


animal_to_pyramid:
	move.l	a3,a5
	move	d0,d6
.copylp
	move.l	(a5)+,(a4)+
	dbra	d6,.copylp
	rts

max_val		dc.l	0
rand_val	dc.l	$23434AF1

ende:
